>From c52ac5b4f7d737f948366f19acb373f5fa4ba0bd Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Fri, 29 Apr 2016 23:56:50 +0200
Subject: [PATCH] Removed unsupported token states from TPS CS.cfg.

The in-line documentation in CS.cfg for TPS has been updated to
remove unsupported token states in the corresponding properties:
* tokendb.allowedTransitions
* tps.operations.allowedTransitions
---
 base/tps-client/doc/CS.cfg.in  | 17 +++++------------
 base/tps/shared/conf/CS.cfg.in | 17 +++++------------
 2 files changed, 10 insertions(+), 24 deletions(-)

diff --git a/base/tps-client/doc/CS.cfg.in b/base/tps-client/doc/CS.cfg.in
index 2d1929ef68403543f629de1d496a8f346a482e4c..a1c032f98f55cb267d6b91fa04e9bb82cabd3e00 100644
--- a/base/tps-client/doc/CS.cfg.in
+++ b/base/tps-client/doc/CS.cfg.in
@@ -1487,9 +1487,8 @@ tokendb._069=#     DAMAGED = 1,
 tokendb._070=#     PERM_LOST = 2,
 tokendb._071=#     SUSPENDED = 3,
 tokendb._072=#     ACTIVE = 4,
-tokendb._073=#     TEMP_LOST_PERM_LOST = 5,
-tokendb._074=#     TERMINATED = 6
-tokendb._075=#########################################
+tokendb._073=#     TERMINATED = 6
+tokendb._074=#########################################
 tokendb.auditLog=[PKI_INSTANCE_PATH]/logs/tokendb-audit.log
 tokendb.hostport=[TOKENDB_HOST]:[TOKENDB_PORT]
 tokendb.ssl=false
@@ -1590,17 +1589,11 @@ tps._002=# tps.cert.list=sslserver,subsystem,audit_signing
 tps._003=# tps.cert.sslserver.nickname=xxx
 tps._005=# tps.cert.subsystem.nickname=xxx
 tps._007=# tps.cert.audit_signing.nickname=xxx
-tps._008=# operations.allowedTransitions:
+tps._008=# tps.operations.allowedTransitions:
 tps._009=#   - token operations, like formatting and enrollment have transitions between the following states
 tps._010=#     AVAILABLE = 0,
-tps._011=#     DAMAGED = 1,
-tps._012=#     PERM_LOST = 2,
-tps._013=#     SUSPENDED =3 ,
-tps._014=#     ACTIVE = 4,
-tps._015=#     TEMP_LOST_PERM_LOST = 5,
-tps._016=#     TERMINATED = 6
-tps._017=# Sample: tps.operations.allowedTransitions=0:0,0:4,4:4,4:6,6:0
-tps._018=########################################
+tps._011=#     ACTIVE = 4,
+tps._012=########################################
 tps.operations.allowedTransitions=0:0,0:4,4:0
 tps.cert.list=sslserver,subsystem,audit_signing
 tps.cert.sslserver.nickname=[HSM_LABEL][NICKNAME]
diff --git a/base/tps/shared/conf/CS.cfg.in b/base/tps/shared/conf/CS.cfg.in
index 0bcaf59e6c44ed19c4ecf693220a7a5ac25f9c80..cfeb776cb5dee74937c3cf5ffcf392acfe236284 100644
--- a/base/tps/shared/conf/CS.cfg.in
+++ b/base/tps/shared/conf/CS.cfg.in
@@ -1959,9 +1959,8 @@ tokendb._069=#     DAMAGED = 1,
 tokendb._070=#     PERM_LOST = 2,
 tokendb._071=#     SUSPENDED = 3,
 tokendb._072=#     ACTIVE = 4,
-tokendb._073=#     TEMP_LOST_PERM_LOST = 5,
-tokendb._074=#     TERMINATED = 6
-tokendb._075=#########################################
+tokendb._073=#     TERMINATED = 6
+tokendb._074=#########################################
 tokendb.activityBaseDN=ou=Activities,[TOKENDB_ROOT]
 tokendb.addConfigTemplate=addConfig.template
 tokendb.addResultTemplate=addResults.template
@@ -2021,17 +2020,11 @@ tps._002=# tps.cert.list=sslserver,subsystem,audit_signing
 tps._003=# tps.cert.sslserver.nickname=xxx
 tps._005=# tps.cert.subsystem.nickname=xxx
 tps._007=# tps.cert.audit_signing.nickname=xxx
-tps._008=# operations.allowedTransitions:
+tps._008=# tps.operations.allowedTransitions:
 tps._009=#   - token operations, like formatting and enrollment have transitions between the following states
 tps._010=#     AVAILABLE = 0,
-tps._011=#     DAMAGED = 1,
-tps._012=#     PERM_LOST = 2,
-tps._013=#     SUSPENDED = 3,
-tps._014=#     ACTIVE = 4,
-tps._015=#     TEMP_LOST_PERM_LOST = 5,
-tps._016=#     TERMINATED = 6
-tps._017=# Sample: tps.operations.allowedTransitions=0:0,0:4,4:4,4:6,6:0
-tps._018=########################################
+tps._011=#     ACTIVE = 4,
+tps._012=########################################
 tps.cert.audit_signing.certusage=ObjectSigner
 tps.cert.audit_signing.nickname=[HSM_LABEL][NICKNAME]
 tps.cert.list=sslserver,subsystem,audit_signing
-- 
2.5.5